import 'package:dbx_platform/dbx_platform.dart';
import 'package:test/test.dart';
import 'dart:io';

const String accessToken = "sl.BGTGxRfFoRclyeHp7gCE4X7iUXTzukkibBRHriK1OuFAHGbjVbKwVeRVZiX3M7k9YJ81_8435Afzr-s4VKxosG26RWOwfqi8ahHZrqGwhyDHKmJjp6Ii0CO6Xl2uRhQXoSlCXVtE";
//Change the variables below before uploading package
const String appKey = "4t391lo19";
const String appSecret = "j9kyv0yopt";
void main() {
  DBX dbx = DBX(
    accessToken: accessToken, 
    appKey: appKey, 
    appSecret: appSecret,
  );
  test("Folder creation test", ()async{
    print(await dbx.createFolder(
        folderToCreate: DBX_Directory(
          path: "/test",
        ),
      ),
    );
  });
  test("Folder exists", ()async{
    print(await dbx.itemExists(
        dbx_item: DBX_Directory(
          path: "/test",
        ),
      ),
    );
  });
  test("Delete folder", ()async{
    print(await dbx.deleteItem(
        dbx_item: DBX_Directory(
          path: "/test",
        ),
      ),
    );
  });
  test("File creation test", ()async{
    print(await dbx.createFile(
        fileToUpload: File("./test_assets/test.odt"), 
        fileToCreate: DBX_File(
          path: "/test.odt",
        ), 
        mode: WriteMode.add,
        mute: true,
      ),
    );
  });
  test("File exists test", ()async{
    print(await dbx.itemExists(
        dbx_item: DBX_File(
          path: "/test.odt",
        ),
      ),
    );
  });
  test("readFileAsBytes test", ()async{
    List<int> bytes = await dbx.readFileAsBytes(
      dbx_file: DBX_File(path: "/test.odt"),
    );
    File file = File("test_database/test.odt");
    file.createSync(recursive: true);
    file.writeAsBytesSync(bytes);
  });
  test("readFileAsBytes test", ()async{
    String stringContent = await dbx.readFileAsString(
      dbx_file: DBX_File(path: "/test.odt"),
    );
    prints(stringContent);
  });
  test("Get item metadata", ()async{
    DBX_Item_Metadata? dbx_item_metadata = await dbx.itemMetadata(
      dbx_item: DBX_File(path: "/test.odt"),
    );
    if(dbx_item_metadata != null){
      print(dbx_item_metadata.name);
      print("Modified by client on : ${dbx_item_metadata.client_modified!.toString()}");
      print("File size: ${dbx_item_metadata.size}");
    }
  });
  test("Folder list test", ()async{
    await dbx.createFolder(
      folderToCreate: DBX_Directory(path: "/database/something_cool"),
    );
    await dbx.createFile(
      fileToUpload: File("test_database/test.odt"), 
      fileToCreate: DBX_File(path: "/database/test.odt"), 
      mode: WriteMode.add,
    );
    List<DBX_Item> items = await dbx.list(
      dbx_directory: DBX_Directory(path: "/database"),
    );
    print(items);
  });
  test("downloadEntireFolderAsZip", ()async{
    await dbx.downloadEntireFolderAsZip(
      dbx_directory: DBX_Directory(path: "/database/"), 
      output: File("test_database/entireFolder.zip"),
    );
  });
}
